﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinTabs;
using Infragistics.Win.UltraWinTabbedMdi;

namespace UltraTabMDIManagerTabOrderWithOpenTab
{
    public partial class Form1 : Form
    {
        public static Form1 MyForm;
        public static int i = 0;
        public Form1()
        {
            InitializeComponent();
            MyForm = this;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CreateNewWindow(false);
        }

        public static void CreateNewWindow(bool IsButtonPress)
        {
            int ActiveTabIndex;
            if(MyForm.ultraTabbedMdiManager1.ActiveTab != null)  ActiveTabIndex = MyForm.ultraTabbedMdiManager1.ActiveTab.Index;
            else ActiveTabIndex =0;

            i++;
            Form2 f = new Form2();
            f.MdiParent = MyForm;
            f.Text = "Form " + i.ToString();
            f.Show();

            if (IsButtonPress) MyForm.ultraTabbedMdiManager1.TabGroups[0].Tabs[MyForm.ultraTabbedMdiManager1.ActiveTab.Index].Reposition(MyForm.ultraTabbedMdiManager1.TabGroups[0].Tabs[ActiveTabIndex], Infragistics.Win.UltraWinTabbedMdi.MdiTabPosition.Next);
          
            int Width = MyForm.ultraTabbedMdiManager1.TabSettings.TabWidth * MyForm.ultraTabbedMdiManager1.TabGroups[0].Tabs.Count + 5;
            MyForm.ultraTabbedMdiManager1.CreationFilter = new CreatingTextUIElement(Width);
        }

        private void ultraTabbedMdiManager1_TabClosed(object sender, Infragistics.Win.UltraWinTabbedMdi.MdiTabEventArgs e)
        {
            if (MyForm.ultraTabbedMdiManager1.TabGroups.Count == 0) return;
            int Width = MyForm.ultraTabbedMdiManager1.TabSettings.TabWidth * MyForm.ultraTabbedMdiManager1.TabGroups[0].Tabs.Count + 5;
            ultraTabbedMdiManager1.CreationFilter = new CreatingTextUIElement(Width);
        }
    }

    public class CreatingTextUIElement : IUIElementCreationFilter
    {
        private int width;

        public CreatingTextUIElement(int Width)
        {
            this.width = Width;
        }
        public void AfterCreateChildElements(UIElement parent)
        {
            TabGroupUIElement El = parent as TabGroupUIElement;
            if (El != null)
            {
                ButtonUIElement newBB = new ButtonUIElement(El);
                newBB.Text = "+";
                newBB.Rect = new Rectangle(El.Rect.X + width, El.Rect.Y + 1, 18, 20);
                El.ChildElements.Add(newBB);
                newBB.ElementClick += new UIElementEventHandler(newBB_ElementClick);
            }
        }

        void newBB_ElementClick(object sender, UIElementEventArgs e)
        {
            Form1.CreateNewWindow(false);
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
